public class Buffer {

  private static final int DEFAULT_SIZE = 4;
  private String[] vett;
  private int testa, coda;
  private int quanti;

  public Buffer(){
    this(DEFAULT_SIZE);
  }

  public Buffer(int n) {
    vett = new String[n];
  }
  
  public synchronized void inserisci(String s) throws InterruptedException {
    while(pieno()) {
      System.out.println(Thread.currentThread().getName() + ": mi blocco, buffer pieno");
      wait();
    }
    vett[coda] = s;
    coda = (coda + 1) % vett.length;
    quanti++;
    notifyAll();
  }
  
  public synchronized String estrai() throws InterruptedException {
    while(vuoto()) {
      System.out.println(Thread.currentThread().getName() + ": mi blocco, buffer vuoto");
      wait();
    }
    String t = vett[testa];
    testa = (testa + 1) % vett.length;
    quanti--; 
    notifyAll();
    return t;
  }

  public synchronized boolean pieno() {
    return quanti == vett.length;
  }

  public synchronized boolean vuoto() {
    return quanti == 0; 
  }
}
